/******************************  PostfixBaumBau.java  *************************/

import AlgoTools.IO;

/** Klasse PostfixBaumBau enthaelt statische Methode postfixBaumBau, 
 *  die einen Postfix-Ausdruck uebergeben bekommt 
 *  und den zugehoerigen Baum zurueckliefert.
 *  Verwendet wird ein Keller ueber Baeumen. 
 */

public class PostfixBaumBau {

  private static boolean is_operator(char c) {    // liefert true, 
    return (c=='+' || c=='-' || c=='*' || c=='/');// falls c ein Operator ist
  } 

  public static Baum postfixBaumBau (char[] ausdruck) { // konstruiert Baum 

    Baum links, rechts;                           // Hilfsbaeume
    char c;                                       // aktuelles Zeichen
 
    Keller k = new Keller();                      // konstruiere einen Keller

    for (int i=0; i < ausdruck.length; i++) {     // durchlaufe Postfix-Ausdruck
        
        c = ausdruck[i];                          // aktuelles Zeichen
        
        if (!is_operator(c))                      // falls Operand,
            k.push(new Baum(new Character(c)));   // lege als Baum auf Keller
        else {                                    // falls Operator,
            rechts = (Baum)k.top(); k.pop();      // hole rechten Sohn
            links  = (Baum)k.top(); k.pop();      // hole linken Sohn 
            k.push(new Baum(links,new Character(c),rechts)); // lege auf Keller 
        }
    }
    return (Baum)k.top();                         // gib Baum im Keller zurueck
  }

  public static void main (String argv[]) {
    char [] zeile = IO.readChars("Bitte Postfix-Ausdruck: ");  // lies Postfix
    Baum wurzel = postfixBaumBau(zeile);          // konstruiere daraus Baum
    IO.print("Inorder lautet:         ");         // kuendige Traversierung an 
    Traverse.klammerinorder(wurzel);              // gib in Klammer-Inorder aus
    IO.println();
  }
}
